<?php

defined( 'ABSPATH' ) OR exit;

require_once(EZSCM_PATH . "class.ezscm_functions.php");

$message = "";

if (!empty($_POST)) {
	// register license
	if ($_POST["action"] == "register_license" && !empty($_POST["purchase_code"])) {
		$result = Ezscm_functions::register_license($_POST["purchase_code"]);

		if (!empty($result["error"])) {
			$message = $result["error"];
		}
		else if (!empty($result["notification"])) {
			$message = $result["notification"];
		}
		else if (!empty($result["success"])) {
			update_option("ezscm_purchase_code", $_POST["purchase_code"]);
			update_option("ezscm_license_activated", 1);

			$message = $result["success"];
		}
		else {
			$message = __("Unknown error.", "ezscm");;
		}
	}
	// revoke license
	else if ($_POST["action"] == "revoke_license") {
		$result = Ezscm_functions::revoke_license(get_option("ezscm_purchase_code"));

		if (!empty($result["error"])) {
			$message = $result["error"];
		}
		else if (!empty($result["notification"])) {
			update_option("ezscm_purchase_code", "");
			update_option("ezscm_license_activated", 0);
			
			$message = $result["notification"];
		}
		else if (!empty($result["success"])) {
			update_option("ezscm_purchase_code", "");
			update_option("ezscm_license_activated", 0);

			$message = $result["success"];
		}
		else {
			$message = __("Unknown error.", "ezscm");;
		}
	}
}

$license           = get_option("ezscm_license_activated", 0);
$license_activated = $license ? __("License registered.", "ezscm") : __("License not registered.", "ezscm");
$license_name      = get_bloginfo("name") . ", " . network_site_url( '/' );
$license_show_content = $license ? "license_active" : "license_inactive";

// check if localhost
if (substr($_SERVER['REMOTE_ADDR'], 0, 4) == '127.' || $_SERVER['REMOTE_ADDR'] == '::1') {
    $license_show_content = "disabled";
}

?>

<div class="ezscm wrap">
	<div class="container-fluid">
		<div class="col-lg-12">
			<h2><?php echo __("Licensing", "ezscm"); ?> - ez Schedule Manager v<?php echo EZSCM_VERSION; ?></h2> 
			<p><?php echo __("In order to receive automatic updates, please register your purchase code here.", "ezscm"); ?></p>
			<p><?php echo __("Only one license per site is allowed. If you uninstall the plugin from a site, the license will be automatically removed from the site so you can register it somewhere else.", "ezscm"); ?></p>
			<p><?php echo sprintf(__("Please report any licensing problems to %s.", "ezscm"), "<a href='mailto:support@ezplugins.de'>support@ezplugins.de</a>"); ?></p>
		</div>

		<?php if (!empty($message)) { ?>
			<div class="col-lg-12">
				<div id="message" class="updated"><?php echo $message; ?></div>
			</div>
		<?php } ?>

		<div class="col-lg-12">
			<form action="" method="POST">
				<?php if ($license_show_content == "license_inactive") { ?>
					<p><?php echo __("Current licensing status:", "ezscm"); ?> <strong><?php echo $license_activated; ?></strong></p>

					<p>
						<?php echo __("The plugin will be licensed for:", "ezscm"); ?> <strong><?php echo $license_name; ?></strong>
					</p>

					<p>
						<label for="purchase_code"><?php echo __("Purchase code", "ezscm"); ?>:</label>
						<input type="text" name="purchase_code" id="purchase_code" />
					</p>

					<input type="hidden" name="action" value="register_license" />
					<input type="submit" value="<?php echo __("Register license", "ezscm"); ?>" class="button button-primary" />
				<?php } else if ($license_show_content == "license_active") { ?>
					<p><?php echo __("Thank your for activating your copy of ez Schedule Manager! :)", "ezscm"); ?></p>
					<p><?php echo __("Licensed for:", "ezscm"); ?> <strong><?php echo $license_name; ?></strong></p>
					
					<input type="hidden" name="action" value="revoke_license" />
					<input type="submit" value="<?php echo __("Revoke license", "ezscm"); ?>" class="button button-primary" />
				<?php } else if ($license_show_content == "disabled") { ?>
					<p><?php echo __("The plugin cannot be licensed on a local machine.", "ezscm"); ?></p>
				<?php } ?>
			</form>
		</div>
	</div>
</div>
