<?php

defined( 'ABSPATH' ) OR exit;

require_once(EZSCM_PATH . "class.ezscm_functions.php");
require_once(EZSCM_PATH . "class.ezscm_backend.php");
$ezscm = new Ezscm_backend();

if (isset($_POST["submit"])) {
	$overwrite = isset($_POST["ezscm-overwrite"]) ? 1 : 0;
	$ezscm->update_settings($_POST["opt"], $overwrite);

	$updated = 1;
}

// schedule settings
$settings = $ezscm->get_settings();

// categorize settings
$settings_cat = array();
foreach ($settings as $cat => $s) {
	$settings_cat[$cat] = $s;
}

?>

<div class="ezscm wrap">
	<?php echo "<h2>" . __("Schedule settings", "ezscm") . " - v" . ezscm_get_version() . "</h2>"; ?>

	<p>
		<?php _e("These options can be changed individually in each form. Saving these options will be applied to new schedules only (when you did not check to overwrite settings).", "ezscm"); ?>
	</p>

	<?php if (isset($updated)) { ?>
		<div id="message" class="updated"><?php echo __("Settings saved.", "ezscm"); ?></div>
	<?php } ?>

	<form method="POST" name="ezscm-form" class="ezscm-form" action="">
		<div id="ezscm-form-options">
			<div id="tabs">
				<ul>
					<?php
					$tabs = array_keys($settings_cat);

					foreach ($tabs as $i => $cat) {
						echo "<li><a href='#tab-{$i}'>{$cat}</a></li>";
					}
					?>
				</ul>

			    <?php

			    $tab_i = 0;
			    foreach ($settings_cat as $cat_name => $cat) {
			    	?>

					<div id="tab-<?php echo $tab_i; ?>">
						<?php
						echo Ezscm_functions::get_settings_table($cat, "opt", "opt");
						?>
					</div>

					<?php

					$tab_i++;
				}
				?>
			</div>
		</div>

		<table class="form-table" style="margin-top: 1em;">
			<!-- overwrite settings -->
			<tr>
				<th scope='row'>
					Overwrite settings
		    	</th>
		    	<td>
		    		<input type="checkbox" name="ezscm-overwrite" id="ezscm-overwrite" value="1" /><br>
		    		<p class="description">Checking this option will overwrite <b>ALL</b> existing schedule settings!</p>
		    	</td>
		    </tr>
		</table>

		<!-- save -->
		<p class="submit"><input type="submit" name="submit" id="submit" class="button button-primary" value="<?php echo __("Save", "ezscm"); ?>" /></p>
	</form>
</div>